#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf openbsd-netcat-svn20120527.tar.bz2
    cd openbsd-netcat-svn20120527
    sed -i 's/SOL_SOCKET, SO_REUSEPORT/SOL_SOCKET, SO_REUSEADDR/' netcat.c
    make
    strip -R .note -R .comment nc
    mkdir -p ../nc/bin
    cp nc ../nc/bin/
    cd ..
    rm -rf openbsd-netcat-svn20120527
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
